Unit II22R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure II22R(var XA :Array of Real; var YA :Array of Real;
                NA :Integer; NN :Integer; X :Real; var Y :Real;
                var DY :Real; var C :Array of Real;
                var D :Array of Real; var IERR :Integer);

implementation

procedure II22R(var XA :Array of Real; var YA :Array of Real;
                NA :Integer; NN :Integer; X :Real; var Y :Real;
                var DY :Real; var C :Array of Real;
                var D :Array of Real; var IERR :Integer);
var
N,I,NS,N1,M,NM,IM,IN_,IT :Integer;
HH,H,W,T,DD :Real;
const
SYS073 :Real = 3.743392E-23;
ZERO :Real = 0.0;
label
_10,_1,_20,_2,_3,_4,_5,_6,_30,_40,_50,_60,_70,_80;
begin
IERR := 0;
N := 2*NN+1;
if ( NA >= N ) 
 then goto _10;
IERR := 66;
UTII10(IERR,22);
goto _80;
_10:
NS := 1;
HH := Abs(X-XA[0]);
for I:=1 to NA do
 begin
  H := Abs(X-XA[I-1]);
  if ( H <> ZERO ) 
   then goto _1;
  Y := YA[I-1];
  DY := ZERO;
  goto _80;
_1:
  if ( H >= HH ) 
   then goto _20;
  NS := I;
  HH := H;
_20:
 end;
if ( NS > N/2 ) 
 then goto _2;
IN_ := 1;
goto _5;
_2:
if ( NS+N/2 < NA ) 
 then goto _3;
IN_ := NA-N+1;
goto _5;
_3:
if ( X > XA[NS-1] ) 
 then goto _4;
IN_ := NS-N div 2;
goto _5;
_4:
IN_ := NS-N div 2+1;
_5:
Y := YA[NS-1];
IN_ := IN_-1;
NS := NS-1-IN_;
for I:=1 to N do
 begin
  IT := I+IN_;
  C[I-1] := YA[IT-1];
  D[I-1] := YA[IT-1]+SYS073;
_6:
 end;
N1 := N-1;
for M:=1 to N1 do
 begin
  NM := N-M;
  for I:=1 to NM do
   begin
    W := C[I+0]-D[I-1];
    IM := I+M+IN_;
    H := XA[IM-1]-X;
    IT := I+IN_;
    T := (XA[IT-1]-X)*D[I-1]/H;
    DD := T-C[I+0];
    if ( DD <> ZERO ) 
     then goto _30;
    IERR := 65;
    UTII10(IERR,22);
    goto _80;
_30:
    DD := W/DD;
    D[I-1] := C[I+0]*DD;
    C[I-1] := T*DD;
_40:
   end;
  if ( 2*NS >= NM ) 
   then goto _50;
  DY := C[NS+0];
  goto _60;
_50:
  DY := D[NS-1];
  NS := NS-1;
_60:
  Y := Y+DY;
_70:
 end;
_80:
end;

end.
